Graphics3D 800,600,32,0
SetBuffer BackBuffer()

; Globals 
Global FL_Pitch#,FL_Yaw#,FL_Roll#,FL_XSpeed#,FL_YSpeed#,FL_ZSpeed#

; MAIN OBJECTS
Global Player_Start_X#=-135, Player_Start_Y#=123, Player_Start_Z#=-152
Global cam = CreateCamera()
CameraRange cam,0.1,10000
PositionEntity cam,Player_Start_X#, Player_Start_Y#, Player_Start_Z#
Global light = CreateLight()

; CreateWorld
pxCreateWorld(0,"key")
pxSetGravity(0,-980.0,0)

; Load World
levelmesh=LoadWorld("map_test.b3d")

; Physic Body of Player
Global player_body = pxBodyCreateCapsule(80,60,70)
pxBodySetPosition player_body,Player_Start_X#, Player_Start_Y#, Player_Start_Z#

; SOME CUBE
cube_body = pxBodyCreateCube(70,70,70,100)
pxBodySetPosition cube_body,-107,374,422
cube = CreateCube()
ScaleEntity cube,70,70,70
EntityColor cube,255,30,30


; =================================== MAIN LOOP =======================================================================================
; timing
gameFPS = 30 
framePeriod = 1000 / gameFPS 
frameTime = MilliSecs () - framePeriod

While Not KeyDown( 1 )
	Repeat 
		frameElapsed = MilliSecs () - frameTime 
	Until frameElapsed 
	frameTicks = frameElapsed / framePeriod 
	frameTween# = Float (frameElapsed Mod framePeriod) / Float (framePeriod) 
	
For frameLimit = 1 To frameTicks 
	If frameLimit = frameTicks Then CaptureWorld 
	frameTime = frameTime + framePeriod
		
	;CALCULATING
	playerwalk1(cam)
	
	;UpdateChar()
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	
	pxRenderPhysic(30,0)		
	pxBodySetEntity(cube,cube_body)

	UpdateWorld
Next		
	RenderWorld frametween

	Text 0,0,"CameraX: "+EntityX#(cam)
	Text 0,10,"CameraY: "+EntityY#(cam)
	Text 0,20,"CameraZ: "+EntityZ#(cam)
	Text 0,30,"CameraPitch: "+EntityPitch#(cam)	
	Text 0,40,"CameraYaw  : "+EntityYaw#(cam)	
	Text 0,50,"CameraRoll : "+EntityRoll#(cam)	
Flip 

Wend 
; =====================================================================================================================================
pxDestroyWorld()

End	


Function playerwalk1(FL_Cam)
    speed#=1.14
	FL_Pitch#=FL_Pitch#-(-MouseYSpeed()*0.02) : FL_Pitch#=FL_Pitch#/1.2
    FL_Yaw#=FL_Yaw#+-(MouseXSpeed()*0.02) : FL_Yaw#=FL_Yaw#/1.2
    MoveMouse (GraphicsWidth()/2,GraphicsHeight()/2)
    FL_ZSpeed#=FL_ZSpeed#+Float(KeyDown(17)-KeyDown(31))*0.92 : FL_ZSpeed#=FL_ZSpeed#/speed#;  w and s
	FL_XSpeed#=FL_XSpeed#+Float(KeyDown(32)-KeyDown(30))*0.92 : FL_XSpeed#=FL_XSpeed#/speed# ; a and d
   	FL_YSpeed#=0
	FL_Roll#=(FL_Yaw#*1.1)-(FL_XSpeed#*2.3)
	FL_Old_Pitch#=EntityPitch#(FL_Cam)
	FL_Old_Roll#=EntityRoll#(FL_Cam)
	RotateEntity FL_Cam, 0,EntityYaw#(FL_Cam),0
		MoveEntity FL_Cam,FL_XSpeed#,0,FL_ZSpeed#
	RotateEntity FL_Cam, FL_Old_Pitch#,EntityYaw#(FL_Cam),FL_Old_Roll#
		Local cp#=EntityPitch(FL_Cam,True)+FL_Pitch#
		If cp<-89 Then cp=-89
		If cp>89 Then cp=89
    RotateEntity FL_Cam,cp,EntityYaw(FL_Cam)+FL_Yaw#,FL_Roll#

    pxBodySetRotation(player_body,0,EntityYaw#(FL_Cam),0)
	pxBodyAddLocalForce(player_body,FL_XSpeed#*pxBodyGetMass(player_body)*70,0,FL_ZSpeed#*pxBodyGetMass(player_body)*70,0)
	PositionEntity FL_cam, pxBodyGetPositionX(player_body),pxBodyGetPositionY(player_body)+40,pxBodyGetPositionZ(player_body)
End Function

Function playerwalk2(FL_Cam)
    speed#=1.14
	FL_Pitch#=FL_Pitch#-(-MouseYSpeed()*0.02) : FL_Pitch#=FL_Pitch#/1.2
    FL_Yaw#=FL_Yaw#+-(MouseXSpeed()*0.02) : FL_Yaw#=FL_Yaw#/1.2
    MoveMouse (GraphicsWidth()/2,GraphicsHeight()/2)
    FL_ZSpeed#=FL_ZSpeed#+Float(KeyDown(17)-KeyDown(31))*0.92 : FL_ZSpeed#=FL_ZSpeed#/speed#;  w and s
	FL_XSpeed#=FL_XSpeed#+Float(KeyDown(32)-KeyDown(30))*0.92 : FL_XSpeed#=FL_XSpeed#/speed# ; a and d
   	FL_YSpeed#=0 
	FL_Roll#=(FL_Yaw#*1.1)-(FL_XSpeed#*2.3)
	FL_Old_Pitch#=EntityPitch#(FL_Cam)
	FL_Old_Roll#=EntityRoll#(FL_Cam)
	RotateEntity FL_Cam, 0,EntityYaw#(FL_Cam),0
		MoveEntity FL_Cam,FL_XSpeed#,0,FL_ZSpeed#
	RotateEntity FL_Cam, FL_Old_Pitch#,EntityYaw#(FL_Cam),FL_Old_Roll#
		Local cp#=EntityPitch(FL_Cam,True)+FL_Pitch#
		If cp<-89 Then cp=-89
		If cp>89 Then cp=89
    RotateEntity FL_Cam,cp,EntityYaw(FL_Cam)+FL_Yaw#,FL_Roll#

    pxBodySetRotation(player_body,0,EntityYaw#(FL_Cam),0)
	pxBodySetLocalLinearSpeed(player_body,FL_XSpeed#*pxBodyGetMass(player_body),pxBodyGetLinearSpeedY(player_body),FL_ZSpeed#*pxBodyGetMass(player_body))
	PositionEntity FL_cam, pxBodyGetPositionX(player_body),pxBodyGetPositionY(player_body)+40,pxBodyGetPositionZ(player_body)
End Function


;====================================================================================================================================
;====================================================================================================================================
Function LoadWorld(file$)
map=LoadAnimMesh(file)
If Not map Return
world=CreatePivot()
meshes=CreatePivot(world)
renderbrushes=CreateMesh(world)
collisionbrushes=CreatePivot(world)
pointentities=CreatePivot(world)
solidentities=CreatePivot(world)
EntityType collisionbrushes,COLLISIONTYPE_BRUSH

For c=1 To CountChildren(map)

	node=GetChild(map,c)	
	classname$=Lower(KeyValue(node,"classname"))
	DebugLog "Loading "+Chr(34)+classname+Chr(34)+"..."
	Select classname
		
		;===============================================================================
		;Map Geometry
		;===============================================================================
		
		Case "mesh"
			EntityParent node,meshes
			c=c-1
			EntityType node,COLLISIONTYPE_MESH

		Case "brush"
			RotateMesh node,EntityPitch(node),EntityYaw(node),EntityRoll(node)
			PositionMesh node,EntityX(node),EntityY(node),EntityZ(node)
			AddMesh node,renderbrushes
			EntityAlpha node,0
			EntityType node,COLLISIONTYPE_BRUSH
			EntityAlpha node,0
			EntityParent node,collisionbrushes
			BodyCreateMesh(node)		
			c=c-1
		
		;===============================================================================
		;Solid Entities
		;===============================================================================
		
		; None.. :)
		
		;===============================================================================
		;Point Entities
		;===============================================================================

		; None.. :)
				
		End Select
	Next

FreeEntity map
Return world
End Function

Function Piece$(s$,entry,char$=" ")
While Instr(s,char+char)
	s=Replace(s,char+char,char)
	Wend
For n=1 To entry-1
	p=Instr(s,char)
	s=Right(s,Len(s)-p)
	Next
p=Instr(s,char)
If p<1
	a$=s
	Else
	a=Left(s,p-1)
	EndIf
Return a
End Function

Function KeyValue$(entity,key$,defaultvalue$="")
properties$=EntityName(entity)
properties$=Replace(properties$,Chr(13),"")
key$=Lower(key)
Repeat
	p=Instr(properties,Chr(10))
	If p test$=(Left(properties,p-1)) Else test=properties
	testkey$=Piece(test,1,"=")
	testkey=Trim(testkey)
	testkey=Replace(testkey,Chr(34),"")
	testkey=Lower(testkey)
	If testkey=key
		value$=Piece(test,2,"=")
		value$=Trim(value$)
		value$=Replace(value$,Chr(34),"")
		Return value
		EndIf
	If Not p Return defaultvalue$
	properties=Right(properties,Len(properties)-p)
	Forever
End Function
;====================================================================================================================================
Function BodyCreateMesh(mesh%)
	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface,0)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function
;====================================================================================================================================